︠ace58b30-9bd5-4138-9f42-bd477ddac330s︠
%md
I have a problem with numerical integration in Sagemath.

The following exemple tries to use a (ridiculously oversimplified) example of a Uniform(-1,1) density, and to integrate it. (And yes, I know that the sought function is $\min(0,\max(\frac{x+1}{2},1))$, thank you very much...).

What bothers me is not the "interesting" part of the integral ; it's what happens in the "uninteresting" (constant) parts...
︡e208f637-e283-47f6-867f-ab2b84dcee12︡{"done":true,"md":"I have a problem with numerical integration in Sagemath.\n\nThe following exemple tries to use a (ridiculously oversimplified) example of a Uniform(-1,1) density, and to integrate it. (And yes, I know that the sought function is $\\min(0,\\max(\\frac{x+1}{2},1))$, thank you very much...).\n\nWhat bothers me is not the \"interesting\" part of the integral ; it's what happens in the \"uninteresting\" (constant) parts..."}
︠bb802eaa-73f7-4aaa-a5b4-22e3db732d87s︠
def dunif(x,a,b):
    if(x<a):return(0)
    elif(x>b):return(0)
    else:return(1/(b-a))
︡965d9c34-df94-43a5-a0c2-41c361cd559a︡{"done":true}︡
︠6cbc810a-5d9b-4697-8a39-1e29cdd8de57i︠
%md
The function itsel plots (and therefore probably computes) fine.
︡84f959d3-374c-4326-bcc1-e951fae9a904︡{"md":"The function itsel plots (and therefore probably computes) fine.\n"}︡
︠24bdfa5c-81c3-4de5-901c-2115ccacd451s︠
plot(lambda x:dunif(x,-1,1),(x,-10,10),figsize=3)
︡060998ba-ab42-42cd-a0c4-aff30d2a0cd5︡{"file":{"filename":"/projects/ec50c702-c618-4167-be42-ec4381d49144/.sage/temp/compute2-us/28871/tmp_gxiggB.svg","show":true,"text":null,"uuid":"b9de93f5-706f-4b1f-b357-a975fe43ced3"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠cbc1ae4e-3156-48cc-8a30-bcbee04016a7i︠
%md
However, its numerical integral has some serious problems :
︡195fcbe2-58e1-489a-bb37-2f21d4bfec62︡{"done":true,"md":"However, its numerical integral has some serious problems :"}
︠9d171c18-499c-4af0-9c86-a86964f39f75s︠
plot(lambda x:numerical_integral(lambda t:dunif(t,-1,1),-oo,x)[0],(x,-10,10), figsize=3)
︡8257747b-ce6b-4586-b085-fe64ee47b76e︡{"file":{"filename":"/projects/ec50c702-c618-4167-be42-ec4381d49144/.sage/temp/compute2-us/28871/tmp_ZuGziq.svg","show":true,"text":null,"uuid":"ab44622c-aaa9-4f26-ab09-e1f94243d5ee"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠b12f58e7-c13e-4dba-9e01-93be728633dci︠
%md
This is probably not an artifact of plot : "zooming" on a problematic region, justs zooms on the same problem (i. e. not dependent of choice of plotting points) :
︡97059ef2-eca7-4c8b-97ee-833842f3abfe︡{"md":"This is probably not an artifact of plot : \"zooming\" on a problematic region, justs zooms on the same problem (i. e. not dependent of choice of plotting points) :\n"}︡
︠e4e33ce8-3795-4b1f-bd0c-76c0b3edcdfbs︠
plot(lambda x:numerical_integral(lambda t:dunif(t,-1,1),-oo,x)[0],(x,7,8), figsize=3)
︡3074519c-473a-4f2e-b62a-0dd08254d26c︡{"file":{"filename":"/projects/ec50c702-c618-4167-be42-ec4381d49144/.sage/temp/compute2-us/28871/tmp_jZjyx_.svg","show":true,"text":null,"uuid":"ef500af9-b135-42e0-8bd4-429096ddb40b"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠38b92c6e-0fe4-4e2f-93dc-44b337853853i︠
%md
This might originate in Maxima, which exhibits the same behaviour :
︡cf2e609b-f28b-4621-8e29-d04a60ac325e︡{"done":true,"md":"This might originate in Maxima, which exhibits the same behaviour :"}
︠a6140a89-f711-4640-8ab9-2af6d9d7dfa0s︠
maxima("define(dunif(x,a,b),if x<a then 0 else if x>b then 0 else 1/(b-a));")
maxima("define(punif(x,a,b),quad_qagi(dunif(t,a,b),t,minf,x)[1]);")
def punif(x,a,b): return(maxima("punif("+str(x)+","+str(a)+","+str(b)+");"))
plot(lambda x:punif(x,-1,1),(x,-10,10),figsize=3)
︡fde4622a-3dbb-4ead-83af-5ed1f6c93026︡{"stdout":"dunif(x,a,b):=ifx<athen0else(ifx>bthen0else1/(b-a))"}︡{"stdout":"\n"}︡{"stdout":"punif(x,a,b):=quad_qagi(ift<athen0else(ift>bthen0else1/(b-a)),t,minf,x,epsrel=1.0e-8,epsabs=0.0,limit=200)[1]\n"}︡{"file":{"filename":"/projects/ec50c702-c618-4167-be42-ec4381d49144/.sage/temp/compute2-us/28871/tmp_Yqd3rY.svg","show":true,"text":null,"uuid":"573be27e-553d-47ba-8a7c-99e51f2a7713"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠6cd0a799-fcd1-4b66-b476-49ae8e980eeei︠
%md
Let's try quad (from mpmath), a nice low-dimension quadrature function, used by sympy :
︡c92b6215-aa3c-4fc5-aadd-1b8a9eb88c03︡{"md":"Let's try quad (from mpmath), a nice low-dimension quadrature function, used by sympy :\n"}︡
︠8f8abee8-99f8-4589-b420-44920168f86fs︠
from mpmath import quad
plot(lambda x:RR(quad(lambda t:dunif(t,-1,1), (-oo, x))),(x,-10,10), figsize=3)
︡4f77cee0-1939-4c91-9d79-41ce21254820︡{"file":{"filename":"/projects/ec50c702-c618-4167-be42-ec4381d49144/.sage/temp/compute2-us/28871/tmp_iGHFcw.svg","show":true,"text":null,"uuid":"50f71bd0-0cf7-4497-8fc5-17fccf596714"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠4205283f-94de-4cc7-ae05-835816966ddbi︠
%md
This becomes ridiculous. Let's zoom in the first problematic region...
︡827c1bf1-00d9-4983-964b-e9b966c15dde︡{"md":"This becomes ridiculous. Let's zoom in the first problematic region...\n"}︡
︠1b7fe738-fd2d-4719-99a9-dc992cb5fa68s︠
plot(lambda x:RR(quad(lambda t:dunif(t,-1,1), (-oo, x))),(x,1,3), figsize=3)
︡0f2b285e-2e0b-4a48-babe-b297a013201c︡{"file":{"filename":"/projects/ec50c702-c618-4167-be42-ec4381d49144/.sage/temp/compute2-us/28871/tmp_adPNOS.svg","show":true,"text":null,"uuid":"4e465122-765f-4bb8-b154-80443b05fe76"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠cb63fe20-9c9b-4291-80d3-cb9437470068i︠
%md
This is becoming *preposterous*. Let's zoom again...
︡a497665e-c7e4-4df3-ab35-a677e029610a︡{"md":"This is becoming *preposterous*. Let's zoom again...\n"}︡
︠2893a1ce-b5b2-4034-9a0c-dad3ceaab9a4s︠
plot(lambda x:RR(quad(lambda t:dunif(t,-1,1), (-oo, x))),(x,2.85, 2.95), figsize=3)
︡31149382-6091-4c3b-aca5-59fced7574b5︡{"file":{"filename":"/projects/ec50c702-c618-4167-be42-ec4381d49144/.sage/temp/compute2-us/28871/tmp_sFNT9F.svg","show":true,"text":null,"uuid":"ebc30d1e-64f3-485f-a93d-716e8657f93f"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠dcff458e-8a2f-4ae0-8908-9134c272bbb0i︠
%md
**Theorem:** Numerical analysis in hard.

**Corollary:** Numerical analysis is harder in apparently simple cases...

**Proofs:** Plotting a constant function is not (not hard). an erroneous plot is not a not-hard plot. See above...

More seriously : What can be the source of the problem ? I am aware that I am using very general algorithms in a special case susceptible of many simplifications (starting with using the closed form of the integral...). But this is a test case, prelude to more complex cases with no obvious simplifications.

Any ideas ?
︡7a8bcd4b-d70d-49c9-ac26-d9f75006451e︡{"md":"**Theorem:** Numerical analysis in hard.\n\n**Corollary:** Numerical analysis is harder in apparently simple cases...\n\n**Proofs:** Plotting a constant function is not (not hard). an erroneous plot is not a not-hard plot. See above...\n\nMore seriously : What can be the source of the problem ? I am aware that I am using very general algorithms in a special case susceptible of many simplifications (starting with using the closed form of the integral...). But this is a test case, prelude to more complex cases with no obvious simplifications.\n\nAny ideas ?\n"}︡
︠b1adf211-3ba8-4a1a-b4c1-5f952a978d97︠

︡65756149-e159-44d0-9ba0-4c165c0ce2bd︡
︠8a5f8a50-697d-4288-9b08-b055f7fb1b43i︠
%md
Well, let's try to force dunif to accept and return floating point values : that should take care of "surprising" conversions :
︡61be870b-0a68-474b-921a-fe23cc38d09c︡{"md":"Well, let's try to force dunif to accept and return floating point values : that should take care of \"surprising\" conversions :\n"}︡
︠baef1f83-46a1-49e7-b3c9-f0740a13c2a4s︠
%cython
cdef double typed_dunif(double x, double a, double b):
    if(x<a):
        return(0.0)
    elif(x>b):
        return(0.0)
    else:
        return(1.0/(b-a))

︡dfa2d8a8-5be6-429b-acfe-e8ac8d45f63b︡{"stdout":"No functions defined."}︡{"stdout":"\n"}︡{"file":{"filename":"/projects/ec50c702-c618-4167-be42-ec4381d49144/.sage/temp/compute2-us/28871/spyx/_projects_ec50c702_c618_4167_be42_ec4381d49144__sage_temp_compute2_us_28871_dir_7wQrxd_a_pyx/_projects_ec50c702_c618_4167_be42_ec4381d49144__sage_temp_compute2_us_28871_dir_7wQrxd_a_pyx_0.html","show":true,"text":"Auto-generated code...","url":"/ec50c702-c618-4167-be42-ec4381d49144/raw/.sage/temp/compute2-us/28871/spyx/_projects_ec50c702_c618_4167_be42_ec4381d49144__sage_temp_compute2_us_28871_dir_7wQrxd_a_pyx/_projects_ec50c702_c618_4167_be42_ec4381d49144__sage_temp_compute2_us_28871_dir_7wQrxd_a_pyx_0.html"},"once":false}︡{"done":true}︡
︠07226c7c-2416-473f-bc34-0a32f8301004s︠
typed_dunif(2,-1,-1)
︡0860cd1e-7177-4719-9bb7-1ad7f15c0ea0︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 957, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nNameError: name 'typed_dunif' is not defined\n"}︡{"done":true}︡
︠6a53275e-fa55-40c6-85c3-9b36016999ff︠
plot(lambda x:numerical_integral(lambda t:typed_dunif(t,-1,1),-oo,x)[0],(x,-10,10), figsize=3)

︡e86939df-fe7d-461c-8337-43102a03a0bb︡{"once":false,"file":{"show":true,"uuid":"553a27ee-d192-4e91-8792-6b75aa3c9d9d","filename":"/projects/ec50c702-c618-4167-be42-ec4381d49144/.sage/temp/compute6dc1/11610/tmp_VwDNZ2.svg"}}︡{"html":"<div align='center'></div>"}︡
︠536f39aa-2f0b-43e4-9205-8638d787336e︠
plot(lambda x:RR(quad(lambda t:typed_dunif(t,-1.0,1.0), (-oo, x))),(x,-10.0,10.0), figsize=3)
︡ec00ae27-e0bb-47c0-aad4-03046a2b0c2b︡{"once":false,"file":{"show":true,"uuid":"65c08a34-4340-4ccc-80d7-02531f9d86d4","filename":"/projects/ec50c702-c618-4167-be42-ec4381d49144/.sage/temp/compute6dc1/11610/tmp_0AeJxy.svg"}}︡{"html":"<div align='center'></div>"}︡
︠97f03424-6cb3-4489-af8b-6f8917299315i︠
%md
Same difference, again... The problem is not here.

Let's try R's integration routine :
︡2cf6efce-2063-4838-bb29-bf0f7cb0e750︡{"md":"Same difference, again... The problem is not here.\n\nLet's try R's integration routine :\n"}︡
︠709487d7-eb30-45ab-9a87-da90232fb8c8s︠
%r
my_punif<-Vectorize(function(x,a,b)integrate(Vectorize(function(t)dunif(t,a,b)),-Inf,x)$value)
## Sanity check
my_punif(seq(-2,2,by=0.5),-1,1)
︡07125ced-2d68-4096-91da-0b5a1431399d︡{"stdout":"[1] 0.00 0.00 0.00 0.25 0.50 0.75 1.00 1.00 1.00"}︡{"done":true}︡
︠530dc3e1-79b2-4fd4-b264-8eadbbb63afas︠
%r
curve(my_punif(x,-1,1),from=-10,to=10)
︡042d0b31-1ce6-40d2-ab23-919833ced74a︡{"stdout":"\n"}︡{"file":{"filename":"/tmp/807d2570-7436-487f-91c0-7f895b41f852.svg","show":true,"text":null,"uuid":"f685ccc3-26f5-47e7-9c40-42ea5d66400e"},"once":false}︡{"stdout":"\n"}︡{"done":true}︡
︠fbfb4c95-4754-47fe-9b87-3e8bf4c71d34i︠
%md
** Same problem ?!?!?! **

So far, we tried three implementations (Sage-Maxima, mpmath, R) of numerical integration routines on the same **trivial** example, which gave variations of the same error.

Either these routines implement variations of the same flawed algorithm, my proble is ill-thought or these routines use the same flawed piece of system software in some critical part of their algorithms...
︡834e42ad-6c59-4dd1-a7d5-b23ac3236f52︡{"md":"** Same problem ?!?!?! **\n\nSo far, we tried three implementations (Sage-Maxima, mpmath, R) of numerical integration routines on the same **trivial** example, which gave variations of the same error.\n\nEither these routines implement variations of the same flawed algorithm, my proble is ill-thought or these routines use the same flawed piece of system software in some critical part of their algorithms...\n"}︡
︠0c024bd3-f2b3-4875-ab44-eeef8e905afa︠









